import java.util.HashSet;
import java.util.Set;

public class CalendarDate implements Comparable<CalendarDate> {
    private int month;
    private int day;

    public CalendarDate(int m, int d) {
        month = m;
        day = d;
    }

    public int compareTo(CalendarDate other) {
        if (month != other.month) {
            return month - other.month;
        } else {
            return day - other.day;
        }
    }

    public String toString() {
        return month + "/" + day;
    }

    public int hashCode() {
        return month * 31 + day * 31 * 31;
    }

    public boolean equals(Object other) {
        if (other.getClass().equals(CalendarDate.class)) {
            CalendarDate date = (CalendarDate) other;
            return date.month == month && date.day == day;
        }
        return false;
    }

    public static void main(String[] args) {
        // System.out.println("a".hashCode());
        // System.out.println("aa".hashCode());
        // System.out.println("aaa".hashCode());

        // System.out.println(97 + 97 * 31);
        // System.out.println(97 + 97 * 31 + 97 * 31 * 31);
        CalendarDate jan31 = new CalendarDate(1, 31);
        CalendarDate april1 = new CalendarDate(4, 1);
        CalendarDate april5 = new CalendarDate(4, 5);
        
        System.out.println(april5.equals(april5));
        // System.out.println(april5.equals(new CalendarDate(4, 5)));
        
        System.out.println((new CalendarDate(4, 5)).hashCode());
        System.out.println(jan31.hashCode());
        System.out.println(april1.hashCode());
        System.out.println(april5.hashCode());
        
        Set<CalendarDate> set = new HashSet<>();
        set.add(april5);
        System.out.println(set.contains(april5));
        set.add(new CalendarDate(4, 5));
        System.out.println(set.contains(new CalendarDate(4, 5)));
        System.out.println(set);
    }
}